<?php
/** 
*
* @package phpBB3
* @version $Id: quickposting.php 442 2007-04-17 02:01:46Z roadydude $
* @copyright (c) 2005 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup(array('posting', 'mcp', 'viewtopic'));

// Grab only parameters needed here
$post_id	= request_var('p', 0);
$topic_id	= request_var('t', 0);
$forum_id	= request_var('f', 0);
$draft_id	= request_var('d', 0);
$lastclick	= request_var('lastclick', 0);
$message	= utf8_normalize_nfc(request_var('message', '', true));

$submit		= (isset($_POST['post'])) ? true : false;

$post_data = array();
$error = false;
$current_time = time();

if (!$auth->acl_get('f_reply', $forum_id) || !$user->data['is_registered'])
{
	if ($user->data['is_registered'])
	{
		$error = $user->lang['USER_CANNOT_REPLY'];
	}
	else
	{
		$error = $user->lang['LOGIN_EXPLAIN_REPLY'];
	}
}

if ($config['flood_interval'] && !$auth->acl_get('f_ignoreflood', $forum_id) && !$error)
{
	// Flood check
	$last_post_time = $user->data['user_lastpost_time'];
	if (($current_time - $last_post_time) < intval($config['flood_interval']))
	{
		$error = $user->lang['FLOOD_ERROR'];
	}
}

if ($message && !$error)
{
	$sql = 'SELECT t.*, f.*
		FROM ' . TOPICS_TABLE . ' t
		LEFT JOIN ' . FORUMS_TABLE . " f ON (f.forum_id = t.forum_id)
		WHERE t.topic_id = $topic_id";
	$result = $db->sql_query($sql);
	$topicrow = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	// Setup look and feel
	$user->setup('viewtopic', $topicrow['forum_style']);

	$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
	$allow_bbcode = $allow_urls = $allow_smilies = true;
	generate_text_for_storage($message, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
	
	// Grab ranks
	$ranks = $cache->obtain_ranks();
   	// Grab icons
	$icons = $cache->obtain_icons();
	// Navigation links
	generate_forum_nav($topicrow);

	$data = array(
		'topic_title'			=> $topicrow['topic_title'],
		'topic_first_post_id'	=> (isset($topicrow['topic_first_post_id'])) ? (int) $topicrow['topic_first_post_id'] : 0,
		'topic_last_post_id'	=> (isset($topicrow['topic_last_post_id'])) ? (int) $topicrow['topic_last_post_id'] : 0,
		'topic_time_limit'		=> (int) $topicrow['topic_time_limit'],
		'topic_attachment'		=> 0,
		'post_id'				=> 0,
		'topic_id'				=> (int) $topic_id,
		'forum_id'				=> (int) $forum_id,
		'icon_id'				=> 0,
		'poster_id'				=> $user->data['user_id'],
		'enable_sig'			=> true,
		'enable_bbcode'			=> true,
		'enable_smilies'		=> true,
		'enable_urls'			=> true,
		'enable_indexing'		=> true,
		'message_md5'			=> (string) md5($message),//$message_md5,
		'post_time'				=> $current_time,
		'post_checksum'			=> '',
		'post_edit_reason'		=> '',
		'post_edit_user'		=> 0,
		'forum_parents'			=> $topicrow['forum_parents'],
		'forum_name'			=> $topicrow['forum_name'],
		'notify'				=> false,//$notify,
		'notify_set'			=> '',//$post_data['notify_set'],
		'poster_ip'				=> $user->ip,//(isset($post_data['poster_ip'])) ? $post_data['poster_ip'] : $user->ip,
		'post_edit_locked'		=> 0,//(int) $post_data['post_edit_locked'],
		'bbcode_bitfield'		=> $bitfield,
		'bbcode_uid'			=> $uid,
		'message'				=> $message,
		'attachment_data'		=> '',
		'filename_data'			=> '',
	);

	$subject = utf8_normalize_nfc(request_var('subject', '', true));
	$subject = (!$subject) ? "Re: {$topicrow['topic_title']}" : $subject;
	
	submit_post('reply', $subject, $user->data['username'], $topicrow['topic_type'], $poll, $data, $update_message = true);
	
	$rank_title = $rank_image = $rank_image_src = $user_age = '';
	$post_id = $data['post_id'];

	//get users age
	$now = getdate(time() + $user->timezone + $user->dst - date('Z'));
	if (!empty($user->data['user_birthday']))
	{
		list($bday_day, $bday_month, $bday_year) = array_map('intval', explode('-', $user->data['user_birthday']));

		if ($bday_year)
		{
			$diff = $now['mon'] - $bday_month;
			if ($diff == 0)
			{
				$diff = ($now['mday'] - $bday_day < 0) ? 1 : 0;
			}
			else
			{
				$diff = ($diff < 0) ? 1 : 0;
			}

			$user_age = (int) ($now['year'] - $bday_year - $diff);
		}
	}

	//get users rank
	get_user_rank($user->data['user_rank'], $user->data['user_posts'] + 1, $rank_title, $rank_image, $rank_image_src);
	//get users icq
	$icq_status = (!empty($user->data['user_icq'])) ? 'http://www.icq.com/people/webmsg.php?to=' . $user->data['user_icq'] : '';
	$icq_status_img = ($icq_status) ? '<img src="http://web.icq.com/whitepages/online?icq=' . $user->data['user_icq'] . '&amp;img=5" width="18" height="18" alt="" />' : '';
	$poster_id = $user->data['user_id'];
	$template->assign_block_vars('postrow', array(
		'POST_AUTHOR_FULL'	=> get_username_string('full', $poster_id, $user->data['username'], $user->data['user_colour'], $user->data['username']),
		'POST_AUTHOR_COLOUR'=> get_username_string('colour', $poster_id, $user->data['username'], $user->data['user_colour']),
		'POST_AUTHOR'		=> get_username_string('username', $poster_id, $user->data['username'], $user->data['user_colour']),
		'U_POST_AUTHOR'		=> get_username_string('profile', $poster_id, $user->data['username'], $user->data['user_colour']),

		'RANK_TITLE'		=> $rank_title,
		'RANK_IMG'			=> $rank_image,
		'RANK_IMG_SRC'		=> $rank_image_src,
		'POSTER_JOINED'		=> $user->format_date($user->data['user_regdate']),
		'POSTER_POSTS'		=> $user->data['user_posts'] + 1,
		'POSTER_FROM'		=> $user->data['user_from'],
		'POSTER_AVATAR'		=> get_user_avatar($user->data['user_avatar'], $user->data['user_avatar_type'], $user->data['user_avatar_width'], $user->data['user_avatar_height'], $user->data['username']),
		'POSTER_WARNINGS'	=> $user->data['user_warnings'],
		'POSTER_AGE'		=> $user_age,

		'POST_DATE'			=> $user->format_date(time()),
		'POST_SUBJECT'		=> $subject,
		'MESSAGE'			=> generate_text_for_display($message, $uid, $bitfield, $options),
		'SIGNATURE'			=> generate_text_for_display($user->data['user_sig'], $user->data['user_sig_bbcode_uid'], $user->data['user_sig_bbcode_bitfield'], 7),

		'MINI_POST_IMG'			=> $user->img('icon_post_target', 'POST'),
		/*'POST_ICON_IMG'			=> ($topic_data['enable_icons'] && !empty($row['icon_id'])) ? $icons[$row['icon_id']]['img'] : '',
		'POST_ICON_IMG_WIDTH'	=> ($topic_data['enable_icons'] && !empty($row['icon_id'])) ? $icons[$row['icon_id']]['width'] : '',
		'POST_ICON_IMG_HEIGHT'	=> ($topic_data['enable_icons'] && !empty($row['icon_id'])) ? $icons[$row['icon_id']]['height'] : '',
*/		'ICQ_STATUS_IMG'		=> $icq_status_img,
		'ONLINE_IMG'			=> $user->img('icon_user_online', 'ONLINE'),
		'S_ONLINE'				=> true,

		'U_EDIT'			=> (($auth->acl_get('f_edit', $forum_id) || $auth->acl_get('m_edit', $forum_id)) ? append_sid("{$phpbb_root_path}posting.$phpEx", "mode=edit&amp;f=$forum_id&amp;p=$post_id") : ''),
		'U_QUOTE'			=> '', //we really don't want the poster to quote a message they just posted
		'U_INFO'			=> ($auth->acl_get('m_info', $forum_id)) ? append_sid("{$phpbb_root_path}mcp.$phpEx", "i=main&amp;mode=post_details&amp;f=$forum_id&amp;p=$post_id", true, $user->session_id) : '',
		'U_DELETE'			=> (($auth->acl_get('f_delete', $forum_id) && !$config['edit_time']) || $auth->acl_get('m_delete', $forum_id)) ? append_sid("{$phpbb_root_path}posting.$phpEx", "mode=delete&amp;f=$forum_id&amp;p=$post_id") : '',

		'U_PROFILE'		=> append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=viewprofile&amp;u=$poster_id"),
		'U_SEARCH'		=> ($auth->acl_get('u_search')) ? append_sid("{$phpbb_root_path}search.$phpEx", 'search_author=' . urlencode($user->data['username']) .'&amp;showresults=posts') : '',
		'U_PM'			=> ($config['allow_privmsg'] && $auth->acl_get('u_sendpm') && ($user->data['user_allow_pm'] || $auth->acl_gets('a_', 'm_') || $auth->acl_getf_global('m_'))) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=pm&amp;mode=compose&amp;action=quotepost&amp;p=' . $post_id) : '',
		'U_EMAIL'		=> (!empty($row['user_allow_viewemail']) || $auth->acl_get('a_email')) ? ($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u=$poster_id") : (($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $user->data['user_email']) : '',
		'U_WWW'			=> $user->data['user_website'],
		'U_ICQ'			=> $icq_status,
		'U_AIM'			=> ($user->data['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u=$poster_id") : '',
		'U_MSN'			=> ($user->data['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u=$poster_id") : '',
		'U_YIM'			=> ($user->data['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . $user->data['user_yim'] . '&amp;.src=pg' : '',
		'U_JABBER'		=> ($user->data['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u=$poster_id") : '',

/*		'U_REPORT'			=> ($auth->acl_get('f_report', $forum_id)) ? append_sid("{$phpbb_root_path}report.$phpEx", 'f=' . $forum_id . '&amp;p=' . $row['post_id']) : '',
		'U_MCP_REPORT'		=> ($auth->acl_get('m_report', $forum_id)) ? append_sid("{$phpbb_root_path}mcp.$phpEx", 'i=reports&amp;mode=report_details&amp;f=' . $forum_id . '&amp;p=' . $row['post_id'], true, $user->session_id) : '',
		'U_MCP_APPROVE'		=> ($auth->acl_get('m_approve', $forum_id)) ? append_sid("{$phpbb_root_path}mcp.$phpEx", 'i=queue&amp;mode=approve_details&amp;f=' . $forum_id . '&amp;p=' . $row['post_id'], true, $user->session_id) : '',
		'U_MINI_POST'		=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'p=' . $row['post_id']) . (($topic_data['topic_type'] == POST_GLOBAL) ? '&amp;f=' . $forum_id : '') . '#p' . $row['post_id'],
		'U_NEXT_POST_ID'	=> ($i < $i_total && isset($rowset[$post_list[$i + 1]])) ? $rowset[$post_list[$i + 1]]['post_id'] : '',
		'U_PREV_POST_ID'	=> $prev_post_id,
		'U_NOTES'			=> ($auth->acl_getf_global('m_')) ? append_sid("{$phpbb_root_path}mcp.$phpEx", 'i=notes&amp;mode=user_notes&amp;u=' . $poster_id, true, $user->session_id) : '',
		'U_WARN'			=> ($auth->acl_getf_global('m_warn') && $poster_id != $poster_id && $poster_id != ANONYMOUS) ? append_sid("{$phpbb_root_path}mcp.$phpEx", 'i=warn&amp;mode=warn_post&amp;f=' . $forum_id . '&amp;p=' . $row['post_id'], true, $user->session_id) : '',
*/
		'POST_ID'			=> $post_id,
		'POSTER_ID'			=> $poster_id,

		'S_HAS_ATTACHMENTS'	=> false,
/*		'S_POST_UNAPPROVED'	=> ($row['post_approved']) ? false : true,
		'S_POST_REPORTED'	=> ($row['post_reported'] && $auth->acl_get('m_report', $forum_id)) ? true : false,
		'S_DISPLAY_NOTICE'	=> $display_notice && $row['post_attachment'],
		'S_FRIEND'			=> ($row['friend']) ? true : false,
		'S_UNREAD_POST'		=> $post_unread,
		'S_FIRST_UNREAD'	=> $s_first_unread,
		'S_CUSTOM_FIELDS'	=> (isset($cp_row['row']) && sizeof($cp_row['row'])) ? true : false,*/
	));
	
	//send the images to the temlate
	$template->assign_vars(array(
		'EDIT_IMG' 			=> $user->img('icon_post_edit', 'EDIT_POST'),
		'DELETE_IMG' 		=> $user->img('icon_post_delete', 'DELETE_POST'),
		'INFO_IMG' 			=> $user->img('icon_post_info', 'VIEW_INFO'),
		'PROFILE_IMG'		=> $user->img('icon_user_profile', 'READ_PROFILE'),
		'SEARCH_IMG' 		=> $user->img('icon_user_search', 'SEARCH_USER_POSTS'),
		'PM_IMG' 			=> $user->img('icon_contact_pm', 'SEND_PRIVATE_MESSAGE'),
		'EMAIL_IMG' 		=> $user->img('icon_contact_email', 'SEND_EMAIL'),
		'WWW_IMG' 			=> $user->img('icon_contact_www', 'VISIT_WEBSITE'),
		'ICQ_IMG' 			=> $user->img('icon_contact_icq', 'ICQ'),
		'AIM_IMG' 			=> $user->img('icon_contact_aim', 'AIM'),
		'MSN_IMG' 			=> $user->img('icon_contact_msnm', 'MSNM'),
		'YIM_IMG' 			=> $user->img('icon_contact_yahoo', 'YIM'),
		'JABBER_IMG'		=> $user->img('icon_contact_jabber', 'JABBER') ,
		'REPORT_IMG'		=> $user->img('icon_post_report', 'REPORT_POST'),
		'REPORTED_IMG'		=> $user->img('icon_topic_reported', 'POST_REPORTED'),
		'UNAPPROVED_IMG'	=> $user->img('icon_topic_unapproved', 'POST_UNAPPROVED'),
		'WARN_IMG'			=> $user->img('icon_user_warn', 'WARN_USER'),
	));
	
	$posts_in_topic = $topicrow['topic_replies_real'];
	if ($posts_in_topic % $config['posts_per_page'])
	{
	
	}
	else
	{
		$pages = floor($posts_in_topic / $config['posts_per_page']);
		$start = $pages * $config['posts_per_page'];
		$template->assign_vars(array(
			'NEXT_PAGE'	=> true,
			'REDIRECT'	=> redirect(append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f=$forum_id&t=$topic_id&start=$start")),
		));
	}
}
$template->assign_vars(array(
	'ERROR'	=> $error,
));
page_header('quick posting');
$template->set_filenames(array(
	'body' => 'quickposting.html')
);

page_footer();
?>